# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class EntityScorecardsInsights(BaseModel):
    """
    Insights about scorecards for a specific entity.
    """ # noqa: E501
    scorecard_count: StrictInt = Field(alias="scorecardCount")
    scorecard_ids: List[StrictStr] = Field(alias="scorecardIds")
    median_rank: StrictStr = Field(alias="medianRank")
    gold_count: StrictInt = Field(alias="goldCount")
    silver_count: StrictInt = Field(alias="silverCount")
    bronze_count: StrictInt = Field(alias="bronzeCount")
    no_rank_count: StrictInt = Field(alias="noRankCount")
    no_data_count: StrictInt = Field(alias="noDataCount")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["scorecardCount", "scorecardIds", "medianRank", "goldCount", "silverCount", "bronzeCount", "noRankCount", "noDataCount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EntityScorecardsInsights from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EntityScorecardsInsights from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "scorecardCount": obj.get("scorecardCount"),
            "scorecardIds": obj.get("scorecardIds"),
            "medianRank": obj.get("medianRank"),
            "goldCount": obj.get("goldCount"),
            "silverCount": obj.get("silverCount"),
            "bronzeCount": obj.get("bronzeCount"),
            "noRankCount": obj.get("noRankCount"),
            "noDataCount": obj.get("noDataCount")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


